<template>
  <b-container fluid>
    <b-card :header="caption">
      <div slot="header">
        Представители
        <div class="card-header-actions">
          <button :disabled="isDisabled()" class="btn btn-primary btn-sm" @click="openAddingModal">
            <i class="icon-plus"></i>
          </button>
        </div>
      </div>
      <nav>
        <b-form-input v-model="filter" placeholder="Поиск..." />
      </nav>
      <b-table :hover="hover" :striped="striped" :bordered="bordered" :small="small" @filtered="onFiltered" :filter="filter" responsive :items="items" :fields="fields" :current-page="currentPage" :per-page="perPage">
        <template slot="action" slot-scope="data">
          <b-button size="sm" @click.stop="info(data.item)" class="mr-1 tableActionbtn" :disabled="isDisabled()">
            <i class="icon-pencil"></i>
          </b-button>
        </template>
      </b-table>
      <nav>
        <b-pagination :total-rows="rowCount" :per-page="perPage" v-model="currentPage" prev-text="Предыдущая" next-text="Следующая" hide-goto-end-buttons/>
      </nav>
    </b-card>

    <b-modal id="modalInfo" @hide="resetModal" title="Редактирование представителя" centered @ok="edit" ok-only>
      <h6>Сотрудник: {{modalInfo.name}} {{modalInfo.lastName}}</h6>
      <b-container fluid>
        <b-form-group>
          <label>Имя</label>
          <b-form-input type="text" name="name2" placeholder="Имя" v-model="modalInfo.name" v-validate="'required'"></b-form-input>
          <span v-show="errors.has('name2')" class="text-danger">{{ errors.first('name2') }}</span>
        </b-form-group>
        <b-form-group>
          <label>Фамилия</label>
          <b-form-input type="text" name="lastName2" placeholder="Фамилия" v-model="modalInfo.lastName" v-validate="'required'"></b-form-input>
          <span v-show="errors.has('lastName2')" class="text-danger">{{ errors.first('lastName2') }}</span>
        </b-form-group>
        <b-form-group>
          <label>Логин</label>
          <b-form-input type="text" name="login2" placeholder="Логин" v-model="modalInfo.login" v-validate="'required'"></b-form-input>
          <span v-show="errors.has('login2')" class="text-danger">{{ errors.first('login2') }}</span>
        </b-form-group>
        <b-form-group>
          <label>Телефон</label>
          <masked-input v-model="modalInfo.phone" class="form-control" mask="\8 (111) 111-11-11" placeholder="Телефон" name="phone2" v-validate="'required'"></masked-input>
          <span v-show="errors.has('phone2')" class="text-danger">{{ errors.first('phone2') }}</span>
        </b-form-group>
        <b-form-group>
          <label>Город</label>
          <b-form-select type="text" name="city2" placeholder="Город" v-model="modalInfo.city" :options="cities" v-validate="'required'"></b-form-select>
          <span v-show="errors.has('city2')" class="text-danger">{{ errors.first('city2') }}</span>
        </b-form-group>
        <b-form-group>
          <label>Email</label>
          <b-form-input v-validate="'required|email'" type="text" name="email2" placeholder="example@mail.com" v-model="modalInfo.email"></b-form-input>
          <span v-show="errors.has('email2')" class="text-danger">{{ errors.first('email2') }}</span>
        </b-form-group>
        <p class="text-danger" v-if="checkPass2">Пароли не совпадают</p>
        <b-form-group>
          <label>Пароль</label>
          <b-form-input type="password" name="password2" placeholder="Пароль" v-model="modalInfo.password" v-validate="'required'"></b-form-input>
          <span v-show="errors.has('password2')" class="text-danger">{{ errors.first('password2') }}</span>
        </b-form-group>
        <b-form-group>
          <label>Подтверждение</label>
          <b-form-input type="password" name="approvePass2" placeholder="Повторите пароль" v-model="approvePass2" v-validate="'required'"></b-form-input>
          <span v-show="errors.has('approvePass2')" class="text-danger">{{ errors.first('approvePass2') }}</span>
        </b-form-group>
        <b-btn class="mt-3" variant="primary" block @click="edit">Изменить</b-btn>
        <!-- <b-btn class="mt-3" variant="outline-danger" block @click="deleting(modalInfo._id)">Удалить</b-btn> -->
      </b-container>
      <div slot="modal-footer" class="w-100">
      </div>
    </b-modal>
    <b-modal id="addingModal" @hide="resetModal" title="Добавление представителя" centered @ok="adding" ok-only>
      <b-container fluid>
        <b-form-group>
          <label>Имя</label>
          <input type="text" class="form-control" name="name" placeholder="Имя" v-model="addedUser.name" v-validate="'required'"></input>
          <span v-show="errors.has('name')" class="text-danger">{{ errors.first('name') }}</span>
        </b-form-group>
        <b-form-group>
          <label>Фамилия</label>
          <input type="text" class="form-control" name="lastName" placeholder="Фамилия" v-model="addedUser.lastName" v-validate="'required'"></input>
          <span v-show="errors.has('lastName')" class="text-danger">{{ errors.first('lastName') }}</span>
        </b-form-group>
        <b-form-group>
          <label>Логин</label>
          <input type="text" class="form-control" name="login" placeholder="Логин" v-model="addedUser.login" v-validate="'required'"></input>
          <span v-show="errors.has('login')" class="text-danger">{{ errors.first('login') }}</span>
        </b-form-group>
        <b-form-group>
          <label>Телефон</label>
          <masked-input v-model="addedUser.phone" class="form-control" mask="\8 (111) 111-11-11" placeholder="Телефон" name="phone" v-validate="'required'"></masked-input>
          <span v-show="errors.has('phone')" class="text-danger">{{ errors.first('phone') }}</span>
        </b-form-group>
        <b-form-group>
          <label>Город</label>
          <b-form-select type="text" name="city" placeholder="Город" v-model="addedUser.city" :options="cities" v-validate="'required'"></b-form-select>
          <span v-show="errors.has('city')" class="text-danger">{{ errors.first('city') }}</span>
        </b-form-group>
        <b-form-group>
          <label>Email</label>
          <input v-validate="'required|email'" type="text" class="form-control" name="email" placeholder="example@mail.com" v-model="addedUser.email"></input>
          <span v-show="errors.has('email')" class="text-danger">{{ errors.first('email') }}</span>
        </b-form-group>
        <span class="text-danger" v-if="checkPass1">Пароли не совпадают</span>
        <b-form-group>
          <label>Пароль</label>
          <input type="password" class="form-control" name="password" placeholder="Пароль" v-model="addedUser.password" v-validate="'required'"></input>
          <span v-show="errors.has('password')" class="text-danger">{{ errors.first('password') }}</span>
        </b-form-group>
        <b-form-group>
          <label>Подтверждение</label>
          <input type="password" class="form-control" name="approvePass" placeholder="Повторите пароль" v-model="approvePass" v-validate="'required'"></input>
          <span v-show="errors.has('approvePass')" class="text-danger">{{ errors.first('approvePass') }}</span>
        </b-form-group>
        <b-btn class="mt-3" variant="primary" block @click="adding">Добавить</b-btn>
      </b-container>
      <div slot="modal-footer" class="w-100">
      </div>
    </b-modal>
  </b-container>
</template>

<script>
import Api from '@/services/Api'
import MaskedInput from 'vue-masked-input'

export default {
  name: 'Employees',
  components: {
    MaskedInput
  },
  props: {
    caption: {
      type: String,
      default: 'Сотрудники'
    },
    hover: {
      type: Boolean,
      default: true
    },
    striped: {
      type: Boolean,
      default: true
    },
    bordered: {
      type: Boolean,
      default: true
    },
    small: {
      type: Boolean,
      default: true
    },
    fixed: {
      type: Boolean,
      default: false
    }
  },
  data: () => {
    return {
      userLevel: localStorage.getItem('level'),
      items: [],
      positions: [],
      cities: [],
      fields: [
        { key: 'name', sortable: true, label: 'Имя' },
        { key: 'lastName', sortable: true, label: 'Фамилия' },
        { key: 'login', sortable: true, label: 'Логин' },
        { key: 'password', sortable: true, label: 'Пароль' },
        { key: 'phone', sortable: true, label: 'Телефон' },
        { key: 'email', sortable: true, label: 'Email' },
        { key: 'city', sortable: true, label: 'Город' },
        { key: 'action', label: 'Действия' }
      ],
      currentPage: 1,
      perPage: 10,
      totalRows: 0,
      rowCount: 1,
      filter: null,
      modalInfo: {
        _id: '',
        name: '',
        lastName: '',
        login: '',
        phone: '',
        email: '',
        city: '',
        password: '',
        status: ''
      },
      addedUser: {
        login: '',
        name: '',
        lastName: '',
        phone: '',
        email: '',
        city: '',
        type: 'employee',
        password: '',
        status: 'active'
      },
      approvePass: '',
      approvePass2: ''
    }
  },
  beforeMount () {
    this.getCities()
    this.getUsers()
    this.getPositions()
  },
  computed: {
    checkPass1 () {
      if (this.approvePass === this.addedUser.password) {
        return false
      } else {
        return true
      }
    },
    checkPass2 () {
      if (this.approvePass2 === this.modalInfo.password) {
        return false
      } else {
        return true
      }
    },
    disabled () {
      if (this.addedUser.name.length > 0 && this.addedUser.lastName.length > 0 && this.addedUser.login.length > 0
        && this.addedUser.city.length > 0 && this.addedUser.phone.length > 0 && this.addedUser.email.length > 0
        && this.addedUser.password.length > 0 && this.approvePass === this.addedUser.password && !this.errors.has('email')) {
        return false
      } else {
        return true
      }
    },
    disabledEdit () {
      if (this.modalInfo.name.length > 0 && this.modalInfo.lastName.length > 0 && this.modalInfo.login.length > 0
        && this.modalInfo.city.length > 0 && this.modalInfo.phone.length > 0 && this.modalInfo.email.length > 0
        && this.modalInfo.password.length > 0 && this.approvePass2 === this.modalInfo.password && !this.errors.has('email')) {
        return false
      } else {
        return true
      }
    }
  },
  methods: {
    isDisabled() {
      return this.userLevel === "2"
    },
    getCities () {
      Api().get('getCities').then(response => {
        this.cities = response.data.map(item => {
          return {
            value: item.name,
            text: item.name
          }
        })
      })
    },
    getUsers () {
      Api().post('getByParameters', {type: 'present'}).then(response => {
        this.items = response.data
        this.rowCount = response.data.length
      })
    },
    getPositions () {
      Api().get('positions').then(response => {
        this.positions = response.data.map(item => {
          return {value: item.name, text: item.name}
        })
      })
    },
    adding (e) {
      this.$validator.validateAll()
      if (this.validateAdding()) {
        this.addedUser.type = 'present'
        this.addedUser.phone = this.addedUser.phone.replace(/\D+/g, "")
        Api().post('adduser', this.addedUser).then(response => {
          this.resetModal()
          window.location.reload()
        })
      }
    },
    edit (e) {
      this.$validator.validateAll()
      if (this.validateEditing()) {
        this.modalInfo.phone = this.modalInfo.phone.replace(/\D+/g, "")
        Api().post('edituser', this.modalInfo).then(response => {
          this.resetModal()
          window.location.reload()
        })
      }
    },
    deleting (_id) {
      const answer = confirm('Нажмите OK для продолжения или Cancel для выхода.')
      if (answer) {
        Api().post('deletingusers', {_id}).then(response => {
          if (response.data.n && response.data.n > 0) {
            this.resetModal()
            window.location.reload()
          } else {
            alert('ne udalilsya')
          }
        })
      } else {
        this.resetModal()
      }
    },
    validateAdding () {
      if (this.addedUser.name.length > 0 && this.addedUser.lastName.length > 0 && this.addedUser.login.length > 0
        && this.addedUser.city.length > 0 && this.addedUser.phone.length > 0 && this.addedUser.email.length > 0
        && this.addedUser.password.length > 0 && this.approvePass === this.addedUser.password && !this.errors.has('email')) {
        return true
      } else {
        return false
      }
    },
    validateEditing () {
      if (this.modalInfo.name.length > 0 && this.modalInfo.lastName.length > 0 && this.modalInfo.login.length > 0
        && this.modalInfo.city.length > 0 && this.modalInfo.phone.length > 0 && this.modalInfo.email.length > 0
        && this.modalInfo.password.length > 0 && this.approvePass2 === this.modalInfo.password && !this.errors.has('email2')) {
        return true
      } else {
        return false
      }
    },
    info (_item) {
      this.modalInfo = _item
      this.$root.$emit('bv::show::modal', 'modalInfo')
    },
    resetModal () {
      this.modalInfo.title = ''
      this.modalInfo.content = ''
      this.approvePass = ''
      this.approvePass2 = ''
      this.addedUser.login = ''
      this.addedUser.name = ''
      this.addedUser.lastName = ''
      this.addedUser.position = ''
      this.addedUser.department = ''
      this.addedUser.phone = ''
      this.addedUser.email = ''
      this.addedUser.password = ''
      this.errors.clear()
    },
    onFiltered (filteredItems) {
      this.rowCount = filteredItems.length
      this.currentPage = 1
    },
    openAddingModal () {
      this.$root.$emit('bv::show::modal', 'addingModal')
    }
  }

}
</script>
